summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: a7d9da6)
raw | patch | inline | side by side (parent: a7d9da6)
author | Thomas Harning <harningt@gmail.com> | |
Thu, 22 Nov 2007 20:19:40 +0000 (15:19 -0500) | ||
committer | Junio C Hamano <gitster@pobox.com> | |
Thu, 22 Nov 2007 22:21:59 +0000 (14:21 -0800) |
Except that this fixes a longstanding corner case bug by
tightening the way underlying diff-index command is run, it is
functionally equivalent to the scripted version.
Signed-off-by: Thomas Harning Jr <harningt@gmail.com>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
tightening the way underlying diff-index command is run, it is
functionally equivalent to the scripted version.
Signed-off-by: Thomas Harning Jr <harningt@gmail.com>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
Makefile | patch | blob | history | |
builtin-merge-ours.c | [new file with mode: 0644] | patch | blob |
builtin.h | patch | blob | history | |
contrib/examples/git-merge-ours.sh | [new file with mode: 0755] | patch | blob |
git-merge-ours.sh | [deleted file] | patch | blob | history |
git.c | patch | blob | history |
diff --git a/Makefile b/Makefile
index cabde8177e1dd2ad03c558339f932b6959a9bce2..7a0ee780dc9c8d7129431ebeafb6805b4a4c9dd6 100644 (file)
--- a/Makefile
+++ b/Makefile
git-sh-setup.sh \
git-am.sh \
git-merge.sh git-merge-stupid.sh git-merge-octopus.sh \
- git-merge-resolve.sh git-merge-ours.sh \
+ git-merge-resolve.sh \
git-lost-found.sh git-quiltimport.sh git-submodule.sh \
git-filter-branch.sh \
git-stash.sh
builtin-mailsplit.o \
builtin-merge-base.o \
builtin-merge-file.o \
+ builtin-merge-ours.o \
builtin-mv.o \
builtin-name-rev.o \
builtin-pack-objects.o \
diff --git a/builtin-merge-ours.c b/builtin-merge-ours.c
--- /dev/null
+++ b/builtin-merge-ours.c
@@ -0,0 +1,28 @@
+/*
+ * Implementation of git-merge-ours.sh as builtin
+ *
+ * Copyright (c) 2007 Thomas Harning Jr
+ * Original:
+ * Original Copyright (c) 2005 Junio C Hamano
+ *
+ * Pretend we resolved the heads, but declare our tree trumps everybody else.
+ */
+#include "git-compat-util.h"
+#include "builtin.h"
+
+static const char *diff_index_args[] = {
+ "diff-index", "--quiet", "--cached", "HEAD", "--", NULL
+};
+#define NARGS (ARRAY_SIZE(diff_index_args) - 1)
+
+int cmd_merge_ours(int argc, const char **argv, const char *prefix)
+{
+ /*
+ * We need to exit with 2 if the index does not match our HEAD tree,
+ * because the current index is what we will be committing as the
+ * merge result.
+ */
+ if (cmd_diff_index(NARGS, diff_index_args, prefix))
+ exit(2);
+ exit(0);
+}
diff --git a/builtin.h b/builtin.h
index 9a6213af126212dc131133cc2e9bf8b8d7a34557..bcb54aaded9707bf7b0d77456f15728db8b4b8ee 100644 (file)
--- a/builtin.h
+++ b/builtin.h
extern int cmd_mailinfo(int argc, const char **argv, const char *prefix);
extern int cmd_mailsplit(int argc, const char **argv, const char *prefix);
extern int cmd_merge_base(int argc, const char **argv, const char *prefix);
+extern int cmd_merge_ours(int argc, const char **argv, const char *prefix);
extern int cmd_merge_file(int argc, const char **argv, const char *prefix);
extern int cmd_mv(int argc, const char **argv, const char *prefix);
extern int cmd_name_rev(int argc, const char **argv, const char *prefix);
diff --git a/contrib/examples/git-merge-ours.sh b/contrib/examples/git-merge-ours.sh
--- /dev/null
@@ -0,0 +1,14 @@
+#!/bin/sh
+#
+# Copyright (c) 2005 Junio C Hamano
+#
+# Pretend we resolved the heads, but declare our tree trumps everybody else.
+#
+
+# We need to exit with 2 if the index does not match our HEAD tree,
+# because the current index is what we will be committing as the
+# merge result.
+
+git diff-index --quiet --cached HEAD || exit 2
+
+exit 0
diff --git a/git-merge-ours.sh b/git-merge-ours.sh
--- a/git-merge-ours.sh
+++ /dev/null
@@ -1,14 +0,0 @@
-#!/bin/sh
-#
-# Copyright (c) 2005 Junio C Hamano
-#
-# Pretend we resolved the heads, but declare our tree trumps everybody else.
-#
-
-# We need to exit with 2 if the index does not match our HEAD tree,
-# because the current index is what we will be committing as the
-# merge result.
-
-git diff-index --quiet --cached HEAD || exit 2
-
-exit 0
index 7604319b5a9e8c12b2f00b4d5e6480445e02daa6..80c2f14a8b805008fc822e9483d2277e69bdcbe3 100644 (file)
--- a/git.c
+++ b/git.c
{ "mailsplit", cmd_mailsplit },
{ "merge-base", cmd_merge_base, RUN_SETUP },
{ "merge-file", cmd_merge_file },
+ { "merge-ours", cmd_merge_ours, RUN_SETUP },
{ "mv", cmd_mv, RUN_SETUP | NEED_WORK_TREE },
{ "name-rev", cmd_name_rev, RUN_SETUP },
{ "pack-objects", cmd_pack_objects, RUN_SETUP },